#include <iostream>
#include <vector>
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data()
{
    size_t number_count;
    cerr << "Enter number count = ";
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++)
    {
        cin >> in.numbers[i];
    }
    cerr << "Enter bin_count = ";
    cin >> in.bin_count;
    return in;
}

void find_minmax(const vector<double>& numbers, double& minimum, double& maximum) {
    minimum = numbers[0];
    maximum = numbers[1];
    for (double i : numbers) {
        if (i < minimum)
            minimum = i;
        if (i > maximum)
            maximum = i;
    }
}
vector<size_t> make_histogram(const vector<double>&numbers, size_t bin_count) {
        double maximum, minimum;
        float LL, LR;

        find_minmax(numbers, minimum, maximum);
        double bin_size = (maximum - minimum) / bin_count;
        vector <size_t> bins(bin_count);
        LL = minimum;
        LR = minimum + bin_size;
        for (int i = 0; i < bin_count; i++) {
            if (i == 0) {
                for (int b = 0; b < numbers.size(); b++) {
                    if ((LL <= numbers[b]) && (numbers[b] < LR))
                        bins[i] += 1;

                }
                LL = LR;
                LR = LL + bin_size;
            }
            if (i == (bin_count - 1)) {
                LR = maximum;
                for (int b = 0; b < numbers.size(); b++) {
                    if ((LL < numbers[b]) && (numbers[b] <= LR))
                        bins[i] += 1;
                }
                break;
            }
            if ((i != 0) && (i != (bin_count - 1))) {
                for (int b = 0; b < numbers.size(); b++) {
                    if ((LL < numbers[b]) && (numbers[b] < LR))
                        bins[i] += 1;
                }
                LL = LR;
                LR = LL + bin_size;
            }
        }
        return bins;
    }
void show_histogram_text(size_t bin_count, const vector<double>&numbers) {

        vector <size_t> bins = make_histogram(numbers, bin_count);
        size_t height;
        const size_t SCREEN_WIDTH = 80;
        const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
        int max_count = 0;
        for (int i = 0; i < bin_count; i++) {
            if (bins[i] > max_count)
                max_count = bins[i];
        }

        for (int i = 0; i < bin_count; i++) {
            if (bins[i] < 10) {
                cout << " ";
            }
            if (bins[i] < 100) {
                cout << " ";
            }
            cout << bins[i] << "|";
            if (max_count > 76) {
                height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count);
                for (int b = 0; b < height; b++)
                    cout << "*";
            }
            else {
                for (int b = 0; b < bins[i]; b++) {
                        cout << "*";
                }
            }
            cout << endl;
        }
    }

int main() {
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(in.bin_count, in.numbers);



    return 0;
}





